uva11090 Going in Cycle!! --- 二分+spfa判负环

给一个带权有向图,求其中是否存在环,若存在,输出环上边权的平均值最小的那个的平均值。

点的范围就50,感觉可以很暴力。。但显然超时了

感觉方法好巧妙,二分平均值,将所有边权减去二分的那个值,然后spfa判断是否有负环

若有负环,则图中存在的所有环的边权平均值一定比枚举值大

反之则小,要是无论枚举值多大都没有负环,说明图中没有环。

#include <iostream>
#include <cstring>
#include <string>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <vector>
#include <queue>
#include <map>
#define inf 0x3f3f3f3f
#define eps 1e-6
#define ll __int64
using namespace std;

struct node
{
    int v,next;
    double w;
}e[10000];

double d[110];
int inq[110],outq[110],head[110],h,n,m;

void init()
{
    memset(head,-1,sizeof head);
    h=0;
}

void addedge(int a,int b,double c)
{
    e[h].v=b;
    e[h].w=c;
    e[h].next=head[a];
    head[a]=h++;
}

int spfa(int st,double cut)
{
    for(int i=0;i<=n;i++)
        d[i]=1e15;
    memset(inq,0,sizeof inq);
    memset(outq,0,sizeof outq);
    d[st]=0;inq[st]=1;
    queue<int> q;
    q.push(st);
    while(!q.empty())
    {
        int x=q.front();
        q.pop();
        inq[x]=0;
        outq[x]++;
        if(outq[x]>n) return 0;//存在负环//是在与源点连通的图上有负环
        for(int i=head[x];i!=-1;i=e[i].next)
        {
            if(d[e[i].v]>d[x]+e[i].w-cut)
            {
                d[e[i].v]=d[x]+e[i].w-cut;
                if(!inq[e[i].v])
                {
                    inq[e[i].v]=1;
                    q.push(e[i].v);
                }
            }
        }
    }
    return 1;
}

int main()
{
    int a,b,i,t,T=1;
    double c,mid,ri,le;
    scanf("%d",&t);
    while(t--)
    {
        printf("Case #%d: ",T++);
        init();
        scanf("%d%d",&n,&m);
        double mmax=0;
        while(m--)
        {
            scanf("%d%d%lf",&a,&b,&c);
            addedge(a,b,c);
            mmax=max(mmax,c);
        }
        /*if(spfa(1,mmax+1))//判断是否连通//这里源点只有1
        {
            printf("No cycle found.\n");
            continue;
        }*/

        le=0;ri=mmax+5;
        while(ri-le>eps)
        {
          //  printf("le:%lf ri:%lf\n",le,ri);
            int flag=0;
            mid=(ri+le)*0.5;
            for(i=1;i<=n;i++)//wa...
            {
                if(!spfa(i,mid))
                {
                    flag=1;
                    break;
                }
            }
            if(!flag)
                le=mid;
            else
                ri=mid;
        }
        if(ri==mmax+5) printf("No cycle found.\n");
        else printf("%.2lf\n",ri);
    }
    return 0;
}

uva11090 Going in Cycle!! --- 二分+spfa判负环

时间: 2024-10-05 05:00:36

uva11090 Going in Cycle!! --- 二分+spfa判负环的相关文章

Poj3259--Wormholes(Spfa 判负环)

Wormholes Time Limit: 2000MS   Memory Limit: 65536K Total Submissions: 36836   Accepted: 13495 Description While exploring his many farms, Farmer John has discovered a number of amazing wormholes. A wormhole is very peculiar because it is a one-way p

UVA - 11090 Going in Cycle!! (Bellman-Ford算法判负环)

Description I I U P C 2 0 06 Problem G: Going in Cycle!! Input: standard input Output: standard output You are given a weighted directed graph with n vertices and m edges. Each cycle in the graph has a weight, which equals to sum of its edges. There

LightOj 1221 - Travel Company(spfa判负环)

1221 - Travel Company PDF (English) Statistics Forum Time Limit: 2 second(s) Memory Limit: 32 MB A travel company is planning to launch their bus service in a new route. So they conducted a survey and made a list of all possible roads connecting diff

poj3259 Wormholes --- spfa判负环

又写了个bellman模板一直RE求解啊... #include <iostream> #include <cstring> #include <string> #include <cstdio> #include <cmath> #include <algorithm> #include <vector> #include <queue> #include <map> #define inf 0x

POJ-1860 Currency Exchange 【spfa判负环】

Description Several currency exchange points are working in our city. Let us suppose that each point specializes in two particular currencies and performs exchange operations only with these currencies. There can be several points specializing in the

POJ 3259 Wormholes(SPFA判负环)

题目链接:http://poj.org/problem?id=3259 题目大意是给你n个点,m条双向边,w条负权单向边.问你是否有负环(虫洞). 这个就是spfa判负环的模版题,中间的cnt数组就是记录这个点松弛进队的次数,次数超过点的个数的话,就说明存在负环使其不断松弛. 1 #include <iostream> 2 #include <cstdio> 3 #include <cstring> 4 #include <queue> 5 using na

bzoj1690:[Usaco2007 Dec]奶牛的旅行(分数规划+spfa判负环)

前段时间准备省选没更,后段(?)时间省选考砸没心情更,最近终于开始恢复刷题了... 题目大意:有n个点m条有向边的图,边上有花费,点上有收益,点可以多次经过,但是收益不叠加,边也可以多次经过,但是费用叠加.求一个环使得收益和/花费和最大,输出这个比值. 显然这就是经典的分数规划题啊,就是最优比率环,那么就二分答案,将所有边(u,v)的边权改为[v的点权-(u,v)原边权*mid],这可以算是最优比率环的公式了吧,然后判一下是否有正环,有的话就说明答案可行.判正环有够别扭的,那就全部改成相反数然后

P2136 拉近距离(spfa判负环)

洛谷—— P2136 拉近距离 题目背景 我是源点,你是终点.我们之间有负权环. ——小明 题目描述 在小明和小红的生活中,有N个关键的节点.有M个事件,记为一个三元组(Si,Ti,Wi),表示从节点Si有一个事件可以转移到Ti,事件的效果就是使他们之间的距离减少Wi. 这些节点构成了一个网络,其中节点1和N是特殊的,节点1代表小明,节点N代表小红,其他代表进展的阶段.所有事件可以自由选择是否进行,但每次只能进行当前节点邻接的.请你帮他们写一个程序,计算出他们之间可能的最短距离. 输入输出格式

BZOJ 3436 小K的农场 查分约束系统 SPFA判负环

题目大意:农场中有一些土地,上面会长一些作物,现在给出一些约束条件,问有没有这种可能. 思路:裸的查分约束系统判负环.记住要跑最长路. CODE: #include <queue> #include <cstdio> #include <cstring> #include <iostream> #include <algorithm> #define MAX 100010 using namespace std; int points,asks;